/*------------------------------------------------------------------------
 |  FILE            MD5PostgreSQL.java
 |  PART OF         Sverre's Simple JDBC Driver for PostgreSQL
 |  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 +----------------------------------------------------------------------*/

package no.shhsoft.postgresql;

import java.util.*;

/**
 *
 *
 * @author   Sverre H. Huseby
 *           &lt;<A HREF="mailto:shh@thathost.com">shh@thathost.com</A>&gt;
 * @version  $Id: MD5PostgreSQL.java,v 1.1 2002/02/05 22:54:25 sverrehu Exp $
 */
public final class MD5PostgreSQL {
/*-----------------------------------------------------------------------+
|  PRIVATE PART                                                          |
+-----------------------------------------------------------------------*/
    private MD5PostgreSQL() {
    }

    private static final void stringToBytes(String s, byte[] buff) {
        int q;

        for (q = s.length() - 1; q >= 0; q--)
            buff[q] = (byte) s.charAt(q);
    }

    public static String oneRound(String s, byte[] salt) {
        int q, len;
        byte[] buff;

        len = s.length();
        buff = new byte[len + salt.length];
        stringToBytes(s, buff);
        for (q = salt.length - 1; q >= 0; q--)
            buff[len + q] = salt[q];

        return MD5.digestToString(buff);
    }

/*-----------------------------------------------------------------------+
|  PUBLIC INTERFACE                                                      |
+-----------------------------------------------------------------------*/
    public static String encryptMD5(String username, String password,
                                    byte[] salt) {
        String s;
        StringBuffer ret;

        ret = new StringBuffer();
        s = oneRound(password, username.getBytes());
        ret.append("md5");
        ret.append(oneRound(s, salt));

        return ret.toString();
    }
}
